let prefix = "sodium_stub"

let prologue_c = "#include <sodium.h>\n"

let prologue_ml = "[@@@warning \"-4\"]\n"

let () =
  let generate_ml, generate_c = ref false, ref false in
  let () =
    Arg.(parse [ "-ml", Set generate_ml, "Generate ML bindings";
                 "-c", Set generate_c, "Generate C bindings"; ])
      (fun _ -> failwith "Unexpected argument")
      "stubgen ( -ml | -c )" in
  match !generate_ml, !generate_c with
  | true, false ->
    print_endline prologue_ml;
    Cstubs.write_ml Format.std_formatter ~prefix (module Okauth_sodium.Bindings)
  | false, true ->
    print_endline prologue_c;
    Cstubs.write_c Format.std_formatter ~prefix (module Okauth_sodium.Bindings)
  | _ -> failwith "Exactly one of -ml and -c flags must be specified"
